PNT				EQU	#0000
Y_SCANLINES 	EQU  189		; сколько строчек
SINUS			EQU	#6000
X_TABLE			EQU #6100

    org #100



	di

	ld hl,sinus
	ld de,SINUS
	ld bc,256
	ldir

	ld sp,#00FE
    ld hl,SCREEN_RENDER	;interrupt_routine
    ld (#0039),hl

	call reg_load
	ld de,PNT
	ld bc,128*255
	xor a
	call FILVRM
	call make_bitmap

   	ld a,#00      
   	out (#99),a    
   	ld a,#8f      
   	out (#99),a    
   	nop               
   	in a,(#99)    
   	ld a,#01      
   	out (#99),a    
   	ld a,#8f      
   	out (#99),a    
  	nop               
   	in a,(#99)    
   	ld a,#02      
   	out (#99),a    
   	ld a,#8f      
   	out (#99),a                  
	ei
loop:	jr loop
;---------------------------------------------------
make_bitmap:
	ld de,PNT
	call SetVdp_Write
	ld a,#F0
	out (#98),a
	ld de,PNT+128
	ld c,256-1			; сколько линий
lines_loop:
	call SetVdp_Write
dots:
	ld b,2
	srl b
dots_loop:
	ld a,#FF
	out (#98),a
	djnz dots_loop
	ld hl,dots+1
	ld b,(hl)
	bit 0,b
	jr z,even
	ld a,#F0
	out (#98),a
even:
	inc b
	ld (hl),b	
	ld hl,128
	add hl,de
	ex de,hl
	dec c
	jr nz,lines_loop
	ret
;---------------------------------------------------
reg_load:
	ld hl,data_reg
	ld bc,#1099
	outi
	jr nz,$-2
	ret

data_reg:
	db #16		; SCREEN5, H-Blank enable
	db 0 or #80	; reg 0

	db #40		; SCREEN ON, V-Blank disable
	db 1 or #80	; reg 1

	db #1F		; PNT=#0000
	db 2 or #80	; reg 2

	db #00		; color
	db 7 or #80	; reg 7

	db #2A		; SPRITE OFF
	db 8 or #80	; reg 8

	db #02		; PAL
	db 9 or #80	; reg 9

	db #97		; регистр 23 - автоинкремент отключен!
	db 17 or #80; reg 17

	db 0
   	db 44 or #80; Рег 44 - секретный ингредиент!!!    
;-----------------------------------------------------
SCREEN_RENDER:
;--- SCREEN ON ---
	ld a,#40
	out (#99),a
	ld a,#81
	out (#99),a
;--- УСТАНАВЛИВАЕМ РЕГИСТ СТАТУСА #2 -----
	ld a,#02	
	out (#99),a
	ld a,#8F	
	out (#99),a
;-----------------------------------------
	ld hl,X_TABLE	; таблица линий
;--- первая линия ----
	ld a,(hl)
	out (#9B),a
;---------------------
	inc l
	ld c,#99
;-------------------------------------------
	ld b,Y_SCANLINES; сколько строчек
render_loop:
;--- расчет следующей линии ---
	ld a,(hl)
	sub l
;------------------------------
	inc l
	in F,(C)		; читаем в рег. флагов
SET_PO_PE:
	JP PE,$-2		; ЧЕТ НЕЧЕТ ПОЛЯ
	out (#9B),a		; номер линии в r23
	djnz render_loop
;--- SCREEN OFF ---   
	ld a,#00      
    out (#99),a    
    ld a,#81      
    out (#99),a    
;------------------ 
    call VBLANK_WAIT     
	call sin_move
;--- УСТАНАВЛИВАЕМ РЕГИСТР СТАТУСА 1 ---
	ld a,#01
	out (#99),a
	ld a,#8f
	out (#99),a
;---------------------------------------
	nop
	in a,(#99)
	ei
	reti
;---------------------------------------
VBLANK_WAIT:
   	in a,(#99)    
   	and #40        
   	jr z,VBLANK_WAIT    
;--- устанавливаем рег 23 в 0 ---
   	xor a          
   	out (#9b),a    
;--- читаем из рег. статуса 2 ---
   	in a,(#99)    
   	and #02        
   	ld a,#ea 			; PE	     
   	jp nz,$+5		   
   	ld a,#e2      		; PO
   	ld (SET_PO_PE),a  	; PE/PO
	ret
;----------------------------------------
sin_move:
sin1:
	ld hl,SINUS
sin2:
	ld de,SINUS+35
	ld bc,X_TABLE
	ld a,192
sin_move_loop:
	push af
	ld a,(de)
	adc (hl)
	ld (bc),a
	inc c
	inc l
	inc l
	inc e
	inc e
	inc e
	pop af
	dec a
	jr nz,sin_move_loop
	ld a,(sin1+1)
	add 5
	ld (sin1+1),a
	ld a,(sin2+1)
	sub 2
	ld (sin2+1),a
	ret
;----------------------------------------
FILVRM:
	call SetVdp_Write
	ld e,a
FILVRM_loop:
	ld a,e
	out (#98),a
	dec bc
	ld a,c
	or b
	jr nz,FILVRM_loop
	ret
;-------------------------------------------------	
SetVdp_Write:						
	push de
	ex af,af'
;--- устанавливаем reg 14 -------------------------
	xor a
 	rlc d
    rla
    rlc d
    rla
    srl d
    srl d
;set_vrm_page:
;	or #00			
	out (#99),a		
	ld a,#8E		
	out (#99),a
;--------------------------------------------------
    ld a,e		
	out (#99),a		
    ld a,d			
    or 64			
  	out (#99),a
	ex af,af'
	pop de
    ret
;--------------------------------------------------
sinus:
	incbin "sin32",7

